//+------------------------------------------------------------------+
//|                                                 FreemanForex.mq4 |
//|                                  Copyright  2008, Freeman Forex |
//|                                            http://www.Freeman.ca |
//+------------------------------------------------------------------+
#define OrderStr "Freeman Forex robot"
#property copyright "Copyright  2008, Freeman Forex"
#property link      "http://www.freeman.ca"
//+---------------------------------------------------+
//|Includes, Library, Error, and other files          |
//+---------------------------------------------------+
#include       <stdlib.mqh>
#include       <stderror.mqh>
//+---------------------------------------------------+
extern int     volume=250;
//+---------------------------------------------------+
//|Profit, Loss, and Stop Management                  |
//+---------------------------------------------------+
extern string  Profit_and_Loss_Mgmnt = "Set Profit Target, Stop Loss, Trailing Stop";
extern int     StopLoss = 17;
extern int     ProfitTarget = 19;
extern bool    UseTrailingStop = true;
extern double  TrailingStop = 14;         // Change to whatever number of pips you wish to trail your position with.
extern string  Trailing_Stop_Type_1 = "Moves stop immediately";
extern string  Trailing_Stop_Type_2 = "Waits until value of Trailing stop is reached";
extern int     TrailingStopType = 1;     // Type 1 moves stop immediately, Type 2 waits til value of TS is reached
//+---------------------------------------------------+
//|Trade and Order Management                         |
//+---------------------------------------------------+
extern string  Trade_Size = "Lot Size and Slippage Control";
extern double  Lots=0.1;
extern int     Slippage = 5;
extern string  Candle_Signal = "1 Candle Close, 0 Current Candle";
extern int     SignalCandle=1;                        //set to 1 if you want to get the candle close 0 for current
extern bool    TradeAtCloseBar = true;
extern string  Trading_Hours = "--Trading Hours Filter--";
extern string  Trading_Hours2 = "UseTradingHours - Enter 0 for false, 1 for true";
extern int     UseTradingHours = 0;
extern string  Spread_Filter = "---Large Spread Filter---";
extern bool    UseSpreadDetection = true;
extern int     MaxSpread = 8;
extern string  Exclude_Friday_Trading = "Friday No Trade - Enter 0 for false, 1 for true";
extern int     UseFridayNoTradeTime = 0;
extern int     FridayFinalHour = 20;
extern string  FreshSignal = "Fresh Signal - Enter 0 for false, 1 for true";
extern string  FreshSignal2 = "1 waits for new signal after starting EA, 0 does not";
extern int     EnterOnFreshSignal = 1;
//+---------------------------------------------------+
//|Money Management                                   |
//+---------------------------------------------------+
extern string Money_Management = "--False disables MM--";
extern bool    UseMoneyManagement = True;           // Change to false to shutdown money management controls.
extern int     MM_Type = 1;
//+---------------------------------------------------+
//|Money Management type 1                            |
//+---------------------------------------------------+
extern string  StrSep1 = "-----MoneyManagementType 1 -----";
extern double  MMRisk=0.15;                         // Risk Factor
extern double  LossMax=1000;                        // Maximum Loss by 1 Lot
//+---------------------------------------------------+
//|Money Management type 2                            |
//+---------------------------------------------------+
extern string  StrSep2 = "-----MoneyManagementType 2 -----";
extern bool    AccountIsMini = true;                // Change to true if trading mini account
extern double  TradeSizePercent = 15;               // Change to whatever percent of equity you wish to risk.
double         MaxLots = 10;
//+---------------------------------------------------+
//|LogFile                                            |
//+---------------------------------------------------+
extern string  TradeLog="FreemanForex";
//+---------------------------------------------------+
string         filename="";
int            Crepeat=0;
int            AlertTime=0;
double         AheadTradeSec = 0;
double         AheadExitSec = 0;
int            TradeBar = 0;
double         MaxTradeTime = 300;
//+---------------------------------------------------+
//|Indicator settings                                 |
//+---------------------------------------------------+
extern string  Indicator_Setting = "--Indicator Settings--";
extern   bool  Crash = false;
extern   int   TimeFrame = 0;
extern   int   Length = 5;
extern   int   Method = 3;
extern   int   Smoothing = 1;
extern   int   Filter = 5;
//+---------------------------------------------------+
extern   bool  RealTime = true;
extern   bool  Steady  = false;
extern   bool  Color = true;
extern   bool  Alerts = true;
extern   bool  EmailON = false;
extern   bool  SignalPrice = true;
extern   color SignalPriceBUY = Yellow;
extern   color SignalPriceSELL = Aqua;
extern   int   CountBars = 1485;
//+---------------------------------------------------+
int CheckTradingTimes ();
//int g1244 = 1
double gd1908;
//int CheckTradingTimes ();
int SpreadOK();
{
if ((Ask - Bid) > (MaxSpread * gd1908)) return( 0 );
return( 1 );
}
int    MagicNumber;                                 // Magic number of the trades. must be unique to identify

double Lotsi=0,mav=0;

bool   TradeAllowed=true;
  
int init() 
  {
    MagicNumber = 3000 + func_Symbol2Val(Symbol())*100 + func_TimeFrame_Const2Val(Period());
  }

int start()
{
int err;
err=GetLastError();

if (TradeAtCloseBar) TradeBar=1;
else TradeBar=0;
 
filename=Symbol() + TradeLog + "-" + Month() + "-" + Day() + ".log";

int li1;

if (li1 == 0)
{
  if (UseTradingHours == 1) {
     li1 = CheckTradingTimes();
   if (li1 == 1) {
       Alert( "Trading has been stopped - wrong time of day" );
   }
   else {
       Alert( "Trading has resumed - time is OK" );
   }

  }
  else {
     Alert( "Trading Time filter not in use" );
  }

}

if (li1 == 0)
{
  if (UseSpreadDetection == 1) {
     if (SpreadOK() == 0) {
       li1 = 1;
    Alert( "Trading has been stopped - Spread too large" );
   }
   else {
       Alert( "Trading has resumed - Spread is OK" );
   }

  }
  else {
     Alert( "Spread Detection not in use" );
  }

}

if (li1 == 0)
{
  if (UseFridayNoTradeTime == 1)
  {
    if (((DayOfWeek() == 5) && (Hour() >= 1)) == 1)
    {
      li1 = 1;
      Alert( "Trading has been stopped - Friday" );
    }

  }

}

//------------------Signal indicators go in here------------------------------//
double sig_buy=0, sig_sell=0, sig_high=0, sig_low=0;

//int   i=0;
 
double   BuyValue=0, SellValue=0;
BuyValue=0; SellValue=0;

sig_buy=iWPR(NULL,0,26,0);
sig_sell=iWPR(NULL,0,27,0);
sig_high=iWPR(NULL,0,29,0);
sig_low=iWPR(NULL,0,30,0);

//-------------------------------------------------------------------------//  
double dblMinStopDistance = MarketInfo(Symbol(),MODE_STOPLEVEL)*MarketInfo(Symbol(), MODE_POINT);
  Comment ("Min Stop Distance : ",dblMinStopDistance,"    ","Volume :");
  
int NumTrades = 0;
  
  for (int i = 0; i < OrdersTotal(); i++)
  {
    OrderSelect(i, SELECT_BY_POS);
 
    if (OrderSymbol() == Symbol())
    {
      if (OrderType() == OP_BUY ) NumTrades++;
      if (OrderType() == OP_SELL )NumTrades++;
    }
  }

  
    if (NumTrades == 0) 
  {
    if (TradeAllowed)
      {
          if (MM_Type == 1)
            Lotsi = MoneyManagement ( UseMoneyManagement, Lots, MMRisk, LossMax);
          else
            Lotsi = GetLots();

//----------------------------------SIGNAL GENERATOR-------------------------------------//
 


            
          //----Long
           if (sig_buy<-97.51 && sig_sell<-97.51 && sig_high<-97.51 && sig_low<-97.51) {     
 BuyValue=1; 
}
           {
            OrderSend(Symbol(), OP_BUY, Lotsi, Ask, Slippage, Ask - StopLoss * Point, Ask + ProfitTarget * Point, 0); 
           }
          if (err>0)
          Print("error(",err,"): ",ErrorDescription(err));
          
          else
           
         //----Short
           if (sig_buy>-5.01 && sig_sell>-5.01 && sig_high>-5.01 && sig_low>-5.01) {     
 SellValue=1;
}
           {
             OrderSend(Symbol(), OP_SELL, Lotsi, Bid, Slippage, Bid + StopLoss * Point, Bid - ProfitTarget * Point, 0);
           }
          if (err>0)
          Print("error(",err,"): ",ErrorDescription(err));
          
          else
            {
             return(0);
           }
        }
     }
//------------------------------------------------TRAILING STOP FUNCTION-------------------------//  
  if (UseTrailingStop)
   {
    for (i = 0; i < OrdersTotal(); i++)
     {
       OrderSelect(i, SELECT_BY_POS, MODE_TRADES);

     if ( OrderSymbol() == Symbol() )
      {
       if ( OrderType() == OP_BUY )
        {
          HandleTrailingStop(OP_BUY,OrderTicket(),OrderOpenPrice(),OrderStopLoss(),OrderTakeProfit());
          }

      if ( OrderType() == OP_SELL)
         {
          HandleTrailingStop(OP_SELL,OrderTicket(),OrderOpenPrice(),OrderStopLoss(),OrderTakeProfit());
	  	  }
	   }
    }
  }

  return(0);
}


// --------------------------------------- Money Management, by Robert Hill--------------------//

double MoneyManagement ( bool flag, double Lots, double risk, double maxloss)
   {
     Lotsi=Lots;
	    
   if ( flag ) Lotsi=NormalizeDouble(Lots*AccountFreeMargin()*risk/maxloss,1);   
     
   if (Lotsi<0.1) Lotsi=0.1;  
   return(Lotsi);
} 

//--------------------------------- Get number of lots for this trade  --------------------//                              

double GetLots()
{
   double lot;
   
   if(UseMoneyManagement)
    {
     lot = LotsOptimized();
      }
       else
        {
         lot = Lots;
   
   
   if(AccountIsMini)
    {
     if (lot < 0.1) lot = 0.1;
      }
       else
      {
     if (lot >= 1.0) lot = MathFloor(lot); else lot = 1.0;
      }
       if (lot > MaxLots) lot = MaxLots;
        }
         return(lot);
        }




//------------------ Calculate optimal lot size based on percent of Account---------------------//                                   


double LotsOptimized()
  {
   double lot=Lots;
//---- select lot size
   lot=NormalizeDouble(MathFloor(AccountFreeMargin()*TradeSizePercent/10000)/10,1);
   
  
  if(AccountIsMini)
  {
    lot = MathFloor(lot*10)/10;
    
   }
   return(lot);
  }
  

//+------------------------------------------------------------------+
//| Modify Open Position Controls                                    |
//|  Try to modify position 3 times                                  |
//+------------------------------------------------------------------+
bool ModifyOrder(int nOrderType, int ord_ticket,double op, double price,double tp, color mColor = CLR_NONE)
{
    int cnt, err;
    double myStop;
    
    myStop = ValidStopLoss (nOrderType, price);
    cnt=0;
   
       if (OrderModify(ord_ticket,op,myStop,tp,0,mColor))
       {
         return(true);
       }
       else 
       {
          err=GetLastError();
          if (err > 1) Print(cnt," Error modifying order : (", ord_ticket , ") " + ErrorDescription(err), " err ",err);
          if (err>0) cnt++;
          Sleep (10000);
          }
       
    
    return(false);
}



//---------------------------------Adjust stop loss so that it is legal------------------------//
double ValidStopLoss(int cmd, double sl)
{
   double  v=iVolume(Symbol(),Period(),0);
   if (sl == 0) return(0.0);
   
   double mySL, myPrice;
   double dblMinStopDistance = MarketInfo(Symbol(),MODE_STOPLEVEL)*MarketInfo(Symbol(), MODE_POINT);
   mySL = sl;

// Check if SlopLoss needs to be modified

   switch(cmd)
   {
   case OP_BUY:
      myPrice = MarketInfo(Symbol(), MODE_BID);
	   if (myPrice - sl < dblMinStopDistance)
	    
		mySL = myPrice - dblMinStopDistance;	// we are long
		break;
      
   case OP_SELL:
      myPrice = MarketInfo(Symbol(), MODE_ASK);
	   if (sl - myPrice < dblMinStopDistance) 
		mySL = myPrice + dblMinStopDistance;	// we are Short
      
      
   }
   return(NormalizeDouble(mySL,MarketInfo(Symbol(), MODE_DIGITS)));
}



//+------------------------------------------------------------------+
//| HandleTrailingStop                                               |
//| Type 1 moves the stoploss without delay.                         |
//| Type 2 waits for price to move the amount of the trailStop       |
//| before moving stop loss then moves like type 1                   |
//| Type 3 uses up to 3 levels for trailing stop                     |
//|      Level 1 Move stop to 1st level                              |
//|      Level 2 Move stop to 2nd level                              |
//|      Level 3 Trail like type 1 by fixed amount other than 1      |          |
//+------------------------------------------------------------------+
int HandleTrailingStop(int type, int ticket, double op, double os, double tp)
{
    double pt, TS=0, myAsk, myBid;
    double bos,bop,opa,osa;
    
    switch(type)
    {
       case OP_BUY:
       {
		 myBid = MarketInfo(Symbol(),MODE_BID);
       switch(TrailingStopType)
       {
        case 1: pt = Point*StopLoss;
                if(myBid-os > pt)
                 ModifyOrder(type, ticket,op,myBid-pt,tp, Aqua);
                break;
        case 2: pt = Point*TrailingStop;
                if(myBid-op > pt && os < myBid - pt)
                 ModifyOrder(type, ticket,op,myBid-pt,tp, Aqua);
                break;
       }
       return(0);
       break;
       }
    case  OP_SELL:
    {
		myAsk = MarketInfo(Symbol(),MODE_ASK);
       switch(TrailingStopType)
       {
        case 1: pt = Point*StopLoss;
                if(os - myAsk > pt)
                 ModifyOrder(type, ticket,op,myAsk+pt,tp, Aqua);
                break;
        case 2: pt = Point*TrailingStop;
                if(op - myAsk > pt && os > myAsk+pt)
                 ModifyOrder(type, ticket,op,myAsk+pt,tp, Aqua);
                break;
       }
    }
    return(0);
    }
}
  
//+------------------------------------------------------------------+
//| Time frame interval appropriation  function                      |
//+------------------------------------------------------------------+

int func_TimeFrame_Const2Val(int Constant ) {
   switch(Constant) {
      case 1:  // M1
         return(1);
      case 5:  // M5
         return(2);
      case 15:
         return(3);
      case 30:
         return(4);
      case 60:
         return(5);
      case 240:
         return(6);
      case 1440:
         return(7);
      case 10080:
         return(8);
      case 43200:
         return(9);
   }
}
int func_Symbol2Val(string symbol) {
   string mySymbol = StringSubstr(symbol,0,6);
	if(mySymbol=="AUDCAD") return(1);
	if(mySymbol=="AUDJPY") return(2);
	if(mySymbol=="AUDNZD") return(3);
	if(mySymbol=="AUDUSD") return(4);
	if(mySymbol=="CHFJPY") return(5);
	if(mySymbol=="EURAUD") return(6);
	if(mySymbol=="EURCAD") return(7);
	if(mySymbol=="EURCHF") return(8);
	if(mySymbol=="EURGBP") return(9);
	if(mySymbol=="EURJPY") return(10);
	if(mySymbol=="EURUSD") return(11);
	if(mySymbol=="GBPCHF") return(12);
	if(mySymbol=="GBPJPY") return(13);
	if(mySymbol=="GBPUSD") return(14);
	if(mySymbol=="NZDUSD") return(15);
	if(mySymbol=="USDCAD") return(16);
	if(mySymbol=="USDCHF") return(17);
	if(mySymbol=="USDJPY") return(18);
	Comment("unexpected Symbol");
	return(19);
}


